import { EntityInventoryComponent } from "@minecraft/server";
import { system, world, Player } from "@minecraft/server";
/** @type {Record<string,string[]>} */
const lores = {
  "ale:ringofstormsfury": [
    "§o§uGain permanent Speed I.",
    "§o§uToggle its power by interacting with it."
  ],
  "ale:arcaneringofmysticism": [
    "§o§uGain permanent Haste I.",
 "§o§uToggle its power by interacting with it."
  ],
  "ale:necklaceofthewarriorswrath": [
    "§o§uGain permanent Strength I.",
    "§o§uToggle its power by interacting with it."
  ],
  "ale:titansbastionring": [
    "§o§uGain permanent Resistance I.",
    "§o§uToggle its power by interacting with it."
  ],
  "ale:archersemblemnecklace": [
    "§o§uGain permanent Jump boost I.",
    "§o§uToggle its power by interacting with it."
  ],
  "ale:ringofcrimsonruby": [
    "§o§uGain permanent Fire Resistance I.",
    "§o§uToggle its power by interacting with it."
  ],
  "ale:necklaceofoceansapphire": [
    "§o§uGain permanent Water Breathing I.",
    "§o§uToggle its power by interacting with it."
  ],
  "ale:ringofradiantcitrine": [
    "§o§uGain permanent Night Vision I.",
    "§o§uToggle its power by interacting with it."
  ],
  "ale:necklaceofcelestialtopaz": [
    "§o§uGain permanent Health Boost.",
    "§o§uToggle its power by interacting with it."
  ],
  "ale:soulboundringofeternity": [
    "§o§uGain permanent Absorption I.",
    "§o§uToggle its power by interacting with it."
  ],
  "ale:necklaceofverdantjade": [
    "§o§uGain permanent Saturation I.",
    "§o§uToggle its power by interacting with it."
  ],
  "ale:ringoftwilighttanzanite": [
    "§o§uGain permanent Levitation I.",
    "§o§uToggle its power by interacting with it."
  ],
  "ale:necklaceoffrozenwinds": [
    "§o§uGain permanent Slow Falling I.",
    "§o§uToggle its power by interacting with it."
  ],
  "ale:bargain_charm": [
    "§o§uVillager trades become cheaper.",
    "§o§uToggle its power by interacting with it."
  ],
  "ale:smelt_amulet": [
    "§o§uOres auto smelt when mined.",
    "§o§uToggle its power by interacting with it."
  ],
  "ale:keep_pendant": [
    "§o§uKeep inventory toggle.",
    "§o§uToggle its power by interacting with it."
  ],
  "ale:vein_amulet": [
    "§o§uBreak all ores in one swing.",
    "§o§uToggle its power by interacting with it.",
    "§o§uMine ores while sneaking."
  ],
  "ale:grove_charm": [
    "§o§uCut down trees in one swing.",
    "§o§uToggle its power by interacting with it."
  ],
  "ale:lantern": [
    "§o§uConstantly emit light around you.",
    "§o§uToggle its power by interacting with it."
  ],
  "ale:antidote_band": [
    "§o§uGain permanent poison immunity.",
    "§o§uToggle its power by interacting with it."
  ],
  "ale:miner_trinket": [
    "§o§uGain permanent Haste II.",
    "§o§uNight Vision II, Saturation II.",
    "§o§uToggle its power by interacting with it."
  ],
  "ale:explorer_amulet": [
    "§o§uGain permanent Speed II",
    "§o§uWater Breathing II, Jump Boost II", 
    "§o§uSlow falling II.",
    "§o§uToggle its power by interacting with it."
  ],
  "ale:warrior_pendant": [
    "§o§uGain permanent Strength II",
    "§o§uAbsorption II, Fire Resistance II",
    "§o§uResistance II.",
    "§o§uToggle its power by interacting with it."
  ],
  "ale:xp_magnet": [
    "§o§uAttract items and XP towards you.",
    "§o§uToggle its power by interacting with it."
  ],
  "ale:resilience_pendant": [
    "§o§qGain Resistance X for 10 seconds.",
    "§o§qGain its power by consuming it."
  ],
  "ale:xp_tickler": [
    "§o§qGain 1 XP point every 10 seconds.",
    "§o§qGain its power by consuming it."
  ],
  "ale:xp_streamer": [
    "§o§qGain 5 XP points every 7 seconds.",
    "§o§qGain its power by consuming it."
  ],
  "ale:xp_torrent": [
    "§o§qGain 10 XP points every 5 seconds.",
    "§o§qGain its power by consuming it."
  ],
  "ale:ability_orb": [
    "§o§qRandomly gain 2 good effects and 1 bad.",
    "§o§qFor 60 seconds.",
    "§o§qGain its power by consuming it."
  ],
  "ale:lucky_orb": [
    "§o§qRandomly gain 1 good effect for 60 seconds.", 
    "§o§qGain its power by consuming it."
  ],
  "ale:quarry_orb": [
    "§o§qDelete any stone or deepslate in a 7x7 area.",
    "§o§qGain its power by consuming it."
  ],
  "ale:health_bounty": [
    "§o§uGain a random effect upon eating food.",
    "§o§uEffects last for 5 seconds.",
    "§o§uToggle its power by interacting with it."
  ],
  "ale:on_off_trinket": [
    "§o§uTurn ON or OFF all the toggle trinkets.",
    "§o§uToggle its power by interacting with it."
  ],
  "ale:trinket_core": [
    "§9Main component for trinket crafting."
  ]





};

/**e
 * @param {import("@minecraft/server").Player} player
 */
export function itemLore(player) {
  const inventory = player.getComponent(EntityInventoryComponent.componentId);
  if (!(inventory instanceof EntityInventoryComponent)) {
    return;
  }
  for (let i = 0; i < inventory.container.size; i++) {
    const item = inventory.container.getItem(i);
    if (!item || item.getLore().length) {
      continue;
    }
    const lore = lores[item.typeId];
    if (lore) {
      item.setLore(["", ...lore]);
      inventory.container.setItem(i, item);
    }
  }
};

system.runInterval(() => {
  for (const player of world.getPlayers()) {
    try {
      itemLore(player);
    } catch {
      continue;
    }
  }
}, 5);
